package cn.com.tenlion.systembase.service.importantevent;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.systembase.pojo.dtos.importantevent.ImportantEventDTO;
import cn.com.tenlion.systembase.pojo.vos.importantevent.ImportantEventVO;
import cn.com.tenlion.systembase.pojo.bos.importantevent.ImportantEventBO;
import cn.com.tenlion.systembase.pojo.pos.importantevent.ImportantEventPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IImportantEventService
 * @Description: 重大事件
 * @Author: CodeFactory
 * @Date: 2021-10-11 17:21:48
 * @Version: 3.0
 **/
public interface IImportantEventService {

    /**
     * 新增重大事件
     *
     * @param importantEventVO
     * @return
     */
    void save(ImportantEventVO importantEventVO);

    /**
     * 新增重大事件
     *
     * @param token
     * @param importantEventVO
     * @return
     */
    void save(String token, ImportantEventVO importantEventVO);

    /**
     * 新增重大事件
     *
     * @param importantEventVO
     * @return importantEventId
     */
    String saveReturnId(ImportantEventVO importantEventVO);

    /**
     * 新增重大事件
     *
     * @param token
     * @param importantEventVO
     * @return importantEventId
     */
    String saveReturnId(String token, ImportantEventVO importantEventVO);

    /**
     * 删除重大事件
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除重大事件
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除重大事件（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改重大事件
     *
     * @param importantEventId
     * @param importantEventVO
     * @return
     */
    void update(String importantEventId, ImportantEventVO importantEventVO);

    /**
     * 修改重大事件
     *
     * @param token
     * @param importantEventId
     * @param importantEventVO
     * @return
     */
    void update(String token, String importantEventId, ImportantEventVO importantEventVO);

    /**
     * 重大事件详情
     *
     * @param params 参数Map
     * @return
     */
    ImportantEventDTO get(Map<String, Object> params);

    /**
     * 重大事件详情
     *
     * @param importantEventId
     * @return
     */
    ImportantEventDTO get(String importantEventId);

    /**
     * 重大事件详情
     *
     * @param params 参数Map
     * @return
     */
    ImportantEventBO getBO(Map<String, Object> params);

    /**
     * 重大事件详情
     *
     * @param importantEventId
     * @return
     */
    ImportantEventBO getBO(String importantEventId);

    /**
     * 重大事件详情
     *
     * @param params 参数Map
     * @return
     */
    ImportantEventPO getPO(Map<String, Object> params);

    /**
     * 重大事件详情
     *
     * @param importantEventId
     * @return
     */
    ImportantEventPO getPO(String importantEventId);

    /**
     * 重大事件列表
     *
     * @param params
     * @return
     */
    List<ImportantEventDTO> list(Map<String, Object> params);

    /**
     * 重大事件列表
     *
     * @param params
     * @return
     */
    List<ImportantEventBO> listBO(Map<String, Object> params);

    /**
     * 重大事件列表
     *
     * @param params
     * @return
     */
    List<ImportantEventPO> listPO(Map<String, Object> params);

    /**
     * 重大事件分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<ImportantEventDTO>> listPage(ListPage page);

    /**
     * 重大事件统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String uid, ImportantEventVO importantEventVO);

    void updateKafka(String uid, ImportantEventVO importantEventVO);

    void deleteKafka(String uid);

}